#include <Wire.h>
#include <TroykaIMU.h>
#include <Adafruit_NeoPixel.h>

#define   LEDS_PIN             12
#define   ANALOG_PIN_RANDOM    A5

#define   PIXEL_NUM            8

#define   ACC_THR              ((float) 1)
#define   DEFAULT_DELAY        ((unsigned int) 500)//скорость которая делится на полученное ускорение
#define   MIN_DELAY            ((unsigned int) 5)


Accelerometer accel;
Adafruit_NeoPixel LEDS = Adafruit_NeoPixel(PIXEL_NUM, LEDS_PIN, NEO_GRB + NEO_KHZ800);

 
void setup()
{
  randomSeed(analogRead(ANALOG_PIN_RANDOM));
  LEDS.begin();
  accel.begin();
  accel.setRange(RANGE_2G);
}
 
void loop()
{
  float Ax;
  float Ay;
  float Az;
  
  accel.readAXYZ(&Ax, &Ay, &Az);
  double Data = sqrt(Ax * Ax + Ay * Ay + Az * Az);
  delay(100);
  accel.readAXYZ(&Ax, &Ay, &Az);
  double newData = sqrt(Ax * Ax + Ay * Ay + Az * Az);

  double DataDif = abs(newData - Data);
    
  if (DataDif > ACC_THR)
  {
    DataDif = DEFAULT_DELAY / DataDif;
    if (DataDif < MIN_DELAY)
      DataDif = MIN_DELAY;
       
    LEDS_Show((long)DataDif);
  }
}
//----------------------------------------
void LEDS_Show(long ShowDelay)
{
  byte RandomPixel;
  int32_t RandomColour;

  for (byte j = 0; j < 5; j++)//количество произвольных вспышек 5
  {
    RandomColour = random(0xFFFFFF);    
    RandomPixel = random(PIXEL_NUM);

    LEDS.setPixelColor(RandomPixel, RandomColour);
    LEDS.show();
    delay(ShowDelay);
    LEDS.setPixelColor(RandomPixel, 0, 0, 0);
    LEDS.show();
    delay(ShowDelay);
  }
}




