#include <Wire.h>
#include <TroykaIMU.h>
#include <Adafruit_NeoPixel.h>

#define   LEDS_PIN             12
#define   ANALOG_PIN_RANDOM    A7

#define   PIXEL_IN_MODULE      8
#define   MODULES_NUM          8
#define   PIXEL_NUM            (PIXEL_IN_MODULE * MODULES_NUM)

#define   ACC_THR              ((float) 1)
#define   DEFAULT_DELAY        ((unsigned int) 15)
#define   MIN_DELAY            ((unsigned int) 1)
#define   Colour               ((int32_t) 0x250914)
#define   ACTIVE_PIXELS        4
#define   PIXEL_SPACE          (4 * ACTIVE_PIXELS)
#define   CYCLE_NUM            2


Accelerometer accel;
Adafruit_NeoPixel LEDS = Adafruit_NeoPixel(PIXEL_NUM, LEDS_PIN, NEO_GRB + NEO_KHZ800);
long ShowDelay = DEFAULT_DELAY;



void setup()
{
  LEDS.begin();
  accel.begin();
  accel.setRange(RANGE_2G);

  for (byte j = 0; j < PIXEL_NUM; j++)
  {
    //LEDS.setPixelColor(j, Colour); //для тени
    LEDS.setPixelColor(j, 0); //для цвета
  }
  LEDS.show();
}
 
void loop()
{
  
  float Ax;
  float Ay;
  float Az;
  
  accel.readAXYZ(&Ax, &Ay, &Az);
  double Data = sqrt(Ax * Ax + Ay * Ay + Az * Az);
  delay(100);
  accel.readAXYZ(&Ax, &Ay, &Az);
  double newData = sqrt(Ax * Ax + Ay * Ay + Az * Az);

  double DataDif = abs(newData - Data);
    
  if (DataDif > ACC_THR)
  {
    DataDif = DEFAULT_DELAY / DataDif;
    if (DataDif < MIN_DELAY)
      DataDif = MIN_DELAY;

    ShowDelay = (long)DataDif;

    for (byte i = 0; i < CYCLE_NUM; i++)
      LEDS_Show();
  }
}
//----------------------------------------
void LEDS_Show()
{
  for (byte j = 0; j < PIXEL_NUM; j++)
  {
    if (j > ACTIVE_PIXELS)
    {
      int SartIndex = j;
      while ((SartIndex - ACTIVE_PIXELS) > 0)
      {
        for (byte i = SartIndex; i > (SartIndex - ACTIVE_PIXELS); i--)
          LEDS.setPixelColor(i, Colour);

        SartIndex -= PIXEL_SPACE;
      }
      LEDS.show();
      delay(ShowDelay);

     for (byte i = j; i >= 1; i--)
       LEDS.setPixelColor(i, 0);
      
      LEDS.show();
      delay(ShowDelay);
    }
  }
}



